var printOrderSlip = require('./printOrderSlip');
var printReceipt = require('./printReceipt');
var sampleReceipt = require('./testReceipt.json');
var printerController = require('./printerController');
var async = require('async');

var samplePrinters = [

    {
        printerName: 'POSPrinter',
        connectionType: 'NET',
        directory: '192.168.0.70',
        printerNo: 2,
        paperWidth: 48
    },
    {
        printerName: 'KitchenPrinter',
        connectionType: 'NET',
        directory: '192.168.0.44',
        printerNo: 2,
        paperWidth: 48
    }

]
const sampleOrderSlip = {
    orderNo: 'A007',
    type: 'ORDER NOW',
    tableNo: '10',
    order: [
        {
            product: 'Cresten Beer',
            quantity: 1
        },
        {
            product: 'Mug Jug',
            quantity: 2
        },
    ],
    remark: 'DO NOT MAKE THESE DRINK'
}

var samplePrintout =
    {
        title: 'BAR 1',
        header: ['companyName', 'address1'],
        footer: ['Thank you', 'Please come again'],
        language: 'ENG',
        printerNo: 2
    }

// loadPrinters(samplePrinters);
// print(samplePrintout, sampleOrderSlip);

function loadPrinters(printers) {
    this.printers = printers;
}
function findPrinters(printerNo) {
    var relavants = new Array();
    for (var i = 0; i < this.printers.length; i++) {
        var printer = printers[i];
        if (printerNo % printer.printerNo == 0) {
            relavants.push(printer);
        }
    }
    return relavants;
}


function print(printout, printable) {
    var todo = [];
    var rPrinters = findPrinters(printout.printerNo);
    // rPrinters = testPrinters(rPrinters);
    if (rPrinters.length != 0) {
        for (var i = 0; i < rPrinters.length; i++) {
            if (printout.title == 'RECEIPT') {
                todo.push(async.apply(printReceipt, rPrinters[i], printout, printable));
            } else {
                todo.push(async.apply(printOrderSlip, rPrinters[i], printout, printable));
            }
        }
        async.series(todo, function (error, result) {
            if (error) {
                console.log('ERROR: ' + error);
            }
            console.log('printed');
        })
    }
    else {
        console.log('no printer is selected ' + printout.title + printout.printerNo);
    }
}

module.exports = {
    load: loadPrinters,
    print: print
}