// this class prints gst registration 

const escpos = require('escpos');
const moment = require('moment');
const currencyFormatter = require('currency-formatter');

function checkHealth(dbPrinter, callback) {
    var paperMaxWidth = dbPrinter.paperWidth;
    var device;

    //setup
    if (dbPrinter.connectionType === 'USB') {
        try {
            device = new escpos.USB();
            hasPrinter = true;
        } catch (err) {
            console.log('No USB Printer found');
        }
    } else if (dbPrinter.connectionType === 'SERIAL') {
        device = new escpos.Serial(dbPrinter.directory, {
            baudRate: 38400,
            autoOpen: false
        });
        hasPrinter = true;
    } else if (dbPrinter.connectionType === 'NET') {
        device = new escpos.Network(dbPrinter.directory);
        hasPrinter = true;
    } else {
        var err = new Error('##printer is not defined in kioskConfig');
        return callback(false);
    }

    if (hasPrinter) {
        printer = new escpos.Printer(device);

        device.open(function (error) {
            if (error) {
                return callback(false);
            }
            printer.close();
            callback(true);
        });
    }

}

module.exports.checkHealth = checkHealth;