module.exports = {
    spaceBuilder: function(maxLen, txtLen) {
        var spacing = '';
        txtLen = txtLen || 0;
        var amtSpace = maxLen - txtLen;
        for (var i = 0; i < amtSpace; i++) {
            spacing += ' ';
        }
        return spacing;
    },
    splitter: function(str, l) {
        var strs = [];
        while (str.length > l) {
            var pos = str.substring(0, l).lastIndexOf(' ');
            pos = pos <= 0 ? l : pos;
            strs.push(str.substring(0, pos));
            var i = str.indexOf(' ', pos) + 1;
            if (i < pos || i > pos + l)
                i = pos;
            str = str.substring(i);
        }
        strs.push(str);
        return strs;
    },
    dateTimeParser: function(value) {
        var datetime = moment(new Date(value).getTime());
        return datetime.format('DD/MM/YYYY HH:mm');
    },
    hasChineseCharacter: function(str) {
        var re1 = new RegExp("[\u4E00-\uFA29]+"); //Chinese character range
        str = str.replace(/\s/g, '');
        return re1.test(str);
    },
    countChineseChar: function(str) {
        var count = 0;
        for (var i = 0; i < str.length; i++) {
            if (str.charCodeAt(i) >= 10000) {
                count++;
            }
        }
        return count;
    },
    hasStringDataInJson: function(key) {
        return key && key !== '';
    }
}